#include <math.h>
#include "ackley_ff.H"


#define ARG_LB -30.0
#define ARG_UB  30.0
#define PI 3.1415927

ackley_ff::ackley_ff(int tmp_dimension) {
  mydim = tmp_dimension;
}

ackley_ff::~ackley_ff() {
  ;
}

int ackley_ff::getdimension() {
  return mydim;
}

double ackley_ff::get_arg_lb() {
  return ARG_LB;
}

double ackley_ff::get_arg_ub() {
  return ARG_UB;
}

double ackley_ff::computefitness(double *argvals) {
  double first_sum;
  double second_sum;
  int i;

  first_sum = 0.0;
  second_sum = 0.0;
  for (i=0; i<mydim; i++) {
    first_sum += argvals[i] * argvals[i];
    second_sum += cos ( 2.0 * PI * argvals[i]);
  }

  return -20.0 * exp( -0.2 * sqrt( first_sum / (mydim * 1.0))) - 
    exp( second_sum / (mydim * 1.0)) + 20 + exp(1);
}



