#!/usr/local/bin/tclsh

set l_option 100
set m_option 15
set a_option 0
set D_option 1.0
set f_option 0
set d_option 30
set g_option 200
set no_of_runs 10

set totalnum 0
for {set j 0} {$j < $no_of_runs} {incr j} {
    exec ./stdES -l ${l_option} -m ${m_option} -a ${a_option} -D ${D_option} -f ${f_option} -d ${d_option} -s $j -g ${g_option}
    incr totalnum
    set fdesc [open "fitness.dat" r]
    foreach line [split [read $fdesc] \n] {
	if {[string match {[0123456789]*} $line]} {
	    regexp {([0-9]+) ([0-9.\-]+) ([0-9.\-]+) ([0-9.\-]+) *} $line litter gen bval aval wval
	    if {[info exists best($gen)]} {
		set best($gen) [expr $best($gen) + $bval]
	    } else {
		set best($gen) $bval
	    }
	    if {[info exists avg($gen)]} {
		set avg($gen) [expr $avg($gen) + $aval]
	    } else {
		set avg($gen) $aval
	    }
	    if {[info exists worst($gen)]} {
		set worst($gen) [expr $worst($gen) + $wval]
	    } else {
		set worst($gen) $wval
	    }
	}
    }
    close $fdesc
}
set fdesc [open "avg_fitness.dat" w]
for {set j 1} {$j <= ${g_option}} {incr j} {
    puts $fdesc "$j [expr $best($j) / $totalnum] [expr $avg($j) / $totalnum] [expr $worst($j) / $totalnum]"
    unset best($j)
    unset avg($j)
    unset worst($j)
}
unset totalnum
close $fdesc

