#include "ind.H"
#include "myrandom.h"

ind::ind(int dim, fitnessfct *fct)
{
  int i;

  objvars = new double[dim];
  mylb = fct->get_arg_lb();
  myub = fct->get_arg_ub();
  mydim = dim;
  myfct = fct;
  nofitnessyet = 1;
  for (i=0; i<mydim; i++) {
    objvars[i] = mylb + randdouble(myub - mylb);
  }
}

ind::~ind()
{
  delete[] objvars;
}

void ind::computefitness()
{
  fitnessvalue = myfct->computefitness(objvars);
  nofitnessyet = 0;
}

double ind::getfitness()
{
  if (nofitnessyet) {
    fprintf(stderr, "no fitness computed yet\n");
    return 0.0;
  } else {
    return fitnessvalue;
  }
}

void ind::setdelta(double d)
{
  fprintf(stderr, "setdelta called for wrong mutation\n");
}

