
#ifndef _IND_H_
#define _IND_H_

#include <stdio.h>
#include "fitnessfct.H"

class ind {
protected:
  double *objvars;                  /* Objektvariablen, d.h. ein Element des
                                       Suchraums - Feld der Laenge 'mydim' */
  double mylb;                      /* Untere Grenze fuer Werte der 
                                       Objektvariablen */ 
  double myub;                      /* Obere Grenze fuer Werte der 
                                       Objektvariablen */ 
  fitnessfct *myfct;                /* Zeiger auf die Fitnessfunktion */
  int mydim;                        /* Dimension des Suchraums */
  double fitnessvalue;              /* Fitnesswert des Individuums */
  char nofitnessyet;                /* Information, ob Fitness schon gesetzt wurde */
public:
  ind(int dim, fitnessfct *fct);    /* Konstruktor */
  ~ind();                           /* Destruktor */
  virtual ind *clone() = 0;         /* erzeugt eine identische Kopie des 
                                       Individuums */
  virtual void mutate() = 0;        /* Mutiert das Individuum */
  virtual void setdelta(double d);  /* setzt die Varianz der Mutation */
  void computefitness();            /* Berechnet Fitness fuer das Individuum */
  double getfitness();              /* Liefert 'fitnessvalue' */
};

#endif
