#include <math.h>
#include "ind_uniform.H"
#include "myrandom.h"

ind_uniform::ind_uniform(int dim, fitnessfct *fct) 
  : ind(dim, fct)
{
  deltanotyetset = 1;
}

ind_uniform::~ind_uniform()
{
  ;
}

ind_uniform *ind_uniform::clone()
{
  int i;
  ind_uniform *result;

  /* Erzeuge ein neues Individuum */
  result = new ind_uniform(mydim, myfct);

  /* Kopiere die Werte aus diesem Individuum */
  for (i=0; i< mydim; i++) {
    result->objvars[i] = objvars[i];
  }
  result->nofitnessyet = nofitnessyet;
  result->fitnessvalue = fitnessvalue;
  result->stratparam = stratparam;
  result->deltanotyetset = deltanotyetset;
  return result;
}

void ind_uniform::mutate()
{
  int i;

  if (deltanotyetset) {
    fprintf(stderr,"Mutation called without initialized delta\n");
  } else {

    /* Mutation des Strategieparameters */
    stratparam *= exp( (1.0/(sqrt(1.0 * mydim))) * randgaussian() );

    /* Mutation der Objektvariablen */
    for (i=0; i<mydim; i++) {
      objvars[i] += stratparam * randgaussian();
    }
    nofitnessyet = 1;
  }
}

void ind_uniform::setdelta(double d)
{
  stratparam = d;
  deltanotyetset = 0;
}



